!/**
 * Highcharts JS v11.4.4 (2024-07-02)
 *
 * Highcharts funnel module
 *
 * (c) 2010-2024 Kacper Madej
 *
 * License: www.highcharts.com/license
 */function(e){"object"==typeof module&&module.exports?(e.default=e,module.exports=e):"function"==typeof define&&define.amd?define("highcharts/modules/funnel3d",["highcharts","highcharts-3d","modules/cylinder"],function(t){return e(t),e.Highcharts=t,e}):e("undefined"!=typeof Highcharts?Highcharts:void 0)}(function(e){"use strict";var t=e?e._modules:{};function i(t,i,r,n){t.hasOwnProperty(i)||(t[i]=n.apply(null,r),"function"==typeof CustomEvent&&e.win.dispatchEvent(new CustomEvent("HighchartsModuleLoaded",{detail:{path:i,module:t[i]}})))}i(t,"Series/Funnel3D/SVGElement3DFunnel.js",[t["Core/Color/Color.js"],t["Core/Globals.js"],t["Core/Renderer/RendererRegistry.js"],t["Core/Utilities.js"]],function(e,t,i,r){let{parse:n}=e,{charts:o}=t,{Element3D:s}=i.getRendererType().prototype,{merge:d}=r;return class extends s{constructor(){super(...arguments),this.mainParts=["top","bottom"],this.parts=["top","bottom","frontUpper","backUpper","frontLower","backLower","rightUpper","rightLower"],this.sideGroups=["upperGroup","lowerGroup"],this.sideParts={upperGroup:["frontUpper","backUpper","rightUpper"],lowerGroup:["frontLower","backLower","rightLower"]},this.pathType="funnel3d"}opacitySetter(e){let t=parseFloat(e),i=this.parts,r=o[this.renderer.chartIndex],n="group-opacity-"+t+"-"+r.index;if(this.parts=this.mainParts,this.singleSetterForParts("opacity",t),this.parts=i,!r.renderer.filterId){for(let e of(r.renderer.definition({tagName:"filter",attributes:{id:n},children:[{tagName:"feComponentTransfer",children:[{tagName:"feFuncA",attributes:{type:"table",tableValues:"0 "+t}}]}]}),this.sideGroups))this[e].attr({filter:"url(#"+n+")"});if(this.renderer.styledMode)for(let e of(r.renderer.definition({tagName:"style",textContent:".highcharts-"+n+" {filter:url(#"+n+")}"}),this.sideGroups))this[e].addClass("highcharts-"+n)}return this}fillSetter(e){let t=n(e),i=t.rgba[3],r={top:n(e).brighten(.1).get(),bottom:n(e).brighten(-.2).get()};if(i<1?(t.rgba[3]=1,t=t.get("rgb"),this.attr({opacity:i})):t=e,t.linearGradient||t.radialGradient||!this.gradientForSides||(t={linearGradient:{x1:0,x2:1,y1:1,y2:1},stops:[[0,n(e).brighten(-.2).get()],[.5,e],[1,n(e).brighten(-.2).get()]]}),t.linearGradient)for(let e of this.sideGroups){let i=this[e].gradientBox,n=t.linearGradient,o=d(t,{linearGradient:{x1:i.x+n.x1*i.width,y1:i.y+n.y1*i.height,x2:i.x+n.x2*i.width,y2:i.y+n.y2*i.height}});for(let t of this.sideParts[e])r[t]=o}else if(d(!0,r,{frontUpper:t,backUpper:t,rightUpper:t,frontLower:t,backLower:t,rightLower:t}),t.radialGradient)for(let e of this.sideGroups){let t=this[e].gradientBox,i=t.x+t.width/2,r=t.y+t.height/2,n=Math.min(t.width,t.height);for(let t of this.sideParts[e])this[t].setRadialReference([i,r,n])}if(this.singleSetterForParts("fill",null,r),this.color=this.fill=e,t.linearGradient)for(let e of[this.frontLower,this.frontUpper]){let t=e.element,i=t&&this.renderer.gradients[t.gradient];i&&"userSpaceOnUse"!==i.attr("gradientUnits")&&i.attr({gradientUnits:"userSpaceOnUse"})}return this}adjustForGradient(){let e;for(let t of this.sideGroups){let i={x:Number.MAX_VALUE,y:Number.MAX_VALUE},r={x:-Number.MAX_VALUE,y:-Number.MAX_VALUE};for(let n of this.sideParts[t])e=this[n].getBBox(!0),i={x:Math.min(i.x,e.x),y:Math.min(i.y,e.y)},r={x:Math.max(r.x,e.x+e.width),y:Math.max(r.y,e.y+e.height)};this[t].gradientBox={x:i.x,width:r.x-i.x,y:i.y,height:r.y-i.y}}}zIndexSetter(){return this.finishedOnAdd&&this.adjustForGradient(),this.renderer.Element.prototype.zIndexSetter.apply(this,arguments)}onAdd(){this.adjustForGradient(),this.finishedOnAdd=!0}}}),i(t,"Series/Funnel3D/Funnel3DComposition.js",[t["Series/Funnel3D/SVGElement3DFunnel.js"],t["Core/Globals.js"],t["Core/Utilities.js"]],function(e,t,i){let{charts:r}=t,{error:n,extend:o,merge:s}=i;function d(e){let t=this.element3d("funnel3d",e),i=this.styledMode,r={"stroke-width":1,stroke:"none"};for(let e of(t.upperGroup=this.g("funnel3d-upper-group").attr({zIndex:t.frontUpper.zIndex}).add(t),[t.frontUpper,t.backUpper,t.rightUpper]))i||e.attr(r),e.add(t.upperGroup);for(let e of(t.lowerGroup=this.g("funnel3d-lower-group").attr({zIndex:t.frontLower.zIndex}).add(t),[t.frontLower,t.backLower,t.rightLower]))i||e.attr(r),e.add(t.lowerGroup);return t.gradientForSides=e.gradientForSides,t}function l(e){this.getCylinderEnd||n("A required Highcharts module is missing: cylinder.js",!0,r[this.chartIndex]);let t=r[this.chartIndex],i=e.alphaCorrection=90-Math.abs(t.options.chart.options3d.alpha%180-90),o=this.cuboidPath.call(this,s(e,{depth:e.width,width:(e.width+e.bottom.width)/2})),d=o.isTop,l=!o.isFront,h=!!e.middle,a=this.getCylinderEnd(t,s(e,{x:e.x-e.width/2,z:e.z-e.width/2,alphaCorrection:i})),p=e.bottom.width,u=s(e,{width:p,x:e.x-p/2,z:e.z-p/2,alphaCorrection:i}),g=this.getCylinderEnd(t,u,!0),f=p,c=u,y=g,x=g,m;h&&(f=e.middle.width,c=s(e,{y:e.y+e.middle.fraction*e.height,width:f,x:e.x-f/2,z:e.z-f/2}),y=this.getCylinderEnd(t,c,!1),x=this.getCylinderEnd(t,c,!1));let w={top:a,bottom:g,frontUpper:this.getCylinderFront(a,y),zIndexes:{group:o.zIndexes.group,top:0!==d?0:3,bottom:1!==d?0:3,frontUpper:l?2:1,backUpper:l?1:2,rightUpper:l?2:1}};return w.backUpper=this.getCylinderBack(a,y),m=Math.min(f,e.width)/Math.max(f,e.width)!=1,w.rightUpper=this.getCylinderFront(this.getCylinderEnd(t,s(e,{x:e.x-e.width/2,z:e.z-e.width/2,alphaCorrection:m?-i:0}),!1),this.getCylinderEnd(t,s(c,{alphaCorrection:m?-i:0}),!h)),h&&(m=Math.min(f,p)/Math.max(f,p)!=1,s(!0,w,{frontLower:this.getCylinderFront(x,g),backLower:this.getCylinderBack(x,g),rightLower:this.getCylinderFront(this.getCylinderEnd(t,s(u,{alphaCorrection:m?-i:0}),!0),this.getCylinderEnd(t,s(c,{alphaCorrection:m?-i:0}),!1)),zIndexes:{frontLower:l?2:1,backLower:l?1:2,rightLower:l?1:2}})),w}return{compose:function(t){let i=t.prototype;i.funnel3d||(i.Element3D.types.funnel3d=e,o(i,{funnel3d:d,funnel3dPath:l}))}}}),i(t,"Series/Funnel3D/Funnel3DSeriesDefaults.js",[],function(){return{center:["50%","50%"],width:"90%",neckWidth:"30%",height:"100%",neckHeight:"25%",reversed:!1,gradientForSides:!0,animation:!1,edgeWidth:0,colorByPoint:!0,showInLegend:!1,dataLabels:{align:"right",crop:!1,inside:!1,overflow:"allow"}}}),i(t,"Series/Funnel3D/Funnel3DPoint.js",[t["Core/Series/SeriesRegistry.js"],t["Core/Utilities.js"]],function(e,t){let{seriesTypes:{column:i}}=e,{extend:r}=t;class n extends i.prototype.pointClass{}return r(n.prototype,{shapeType:"funnel3d"}),n}),i(t,"Series/Funnel3D/Funnel3DSeries.js",[t["Series/Funnel3D/Funnel3DComposition.js"],t["Series/Funnel3D/Funnel3DSeriesDefaults.js"],t["Series/Funnel3D/Funnel3DPoint.js"],t["Core/Globals.js"],t["Core/Math3D.js"],t["Core/Series/SeriesRegistry.js"],t["Core/Utilities.js"]],function(e,t,i,r,n,o,s){let{noop:d}=r,{perspective:l}=n,{series:h,seriesTypes:{column:a}}=o,{extend:p,merge:u,pick:g,relativeLength:f}=s;class c extends a{alignDataLabel(e,t,i){let r=e.dlBoxRaw,n=this.chart.inverted,o=e.plotY>g(this.translatedThreshold,this.yAxis.len),s=g(i.inside,!!this.options.stacking),d={x:r.x,y:r.y,height:0};i.align=g(i.align,!n||s?"center":o?"right":"left"),i.verticalAlign=g(i.verticalAlign,n||s?"middle":o?"top":"bottom"),"top"!==i.verticalAlign&&(d.y+=r.bottom/("bottom"===i.verticalAlign?1:2)),d.width=this.getWidthAt(d.y),this.options.reversed&&(d.width=r.fullWidth-d.width),s?d.x-=d.width/2:"left"===i.align?(i.align="right",d.x-=1.5*d.width):"right"===i.align?(i.align="left",d.x+=d.width/2):d.x-=d.width/2,e.dlBox=d,a.prototype.alignDataLabel.apply(this,arguments)}bindAxes(){h.prototype.bindAxes.apply(this,arguments),p(this.xAxis.options,{gridLineWidth:0,lineWidth:0,title:void 0,tickPositions:[]}),u(!0,this.yAxis.options,{gridLineWidth:0,title:void 0,labels:{enabled:!1}})}translate(){h.prototype.translate.apply(this,arguments);let e=this.chart,t=this.options,i=t.reversed,r=t.ignoreHiddenPoint,n=e.plotWidth,o=e.plotHeight,s=t.center,d=f(s[0],n),a=f(s[1],o),u=f(t.width,n),c=f(t.height,o),y=f(t.neckWidth,n),x=f(t.neckHeight,o),m=a-c/2+c-x,w=this.points,b=0,C=0,F,S,U,G,L,j,D,A,k;for(let e of(this.getWidthAt=S=function(e){return e>m||c===x?y:y+(u-y)*(1-(e-(a-c/2))/(c-x))},this.center=[d,a,c],this.centerX=d,w))r&&!1===e.visible||(b+=e.y);for(let n of w)D=null,U=b?n.y/b:0,j=(L=a-c/2+C*c)+U*c,F=S(L),A=j-L,k={gradientForSides:g(n.options.gradientForSides,t.gradientForSides),x:d,y:L,height:A,width:F,z:1,top:{width:F}},F=S(j),k.bottom={fraction:U,width:F},L>=m?k.isCylinder=!0:j>m&&(D=j,F=S(m),j=m,k.bottom.width=F,k.middle={fraction:A?(m-L)/A:0,width:F}),i&&(k.y=L=a+c/2-(C+U)*c,k.middle&&(k.middle.fraction=1-(A?k.middle.fraction:0)),F=k.width,k.width=k.bottom.width,k.bottom.width=F),n.shapeArgs=p(n.shapeArgs,k),n.percentage=100*U,n.plotX=d,i?n.plotY=a+c/2-(C+U/2)*c:n.plotY=(L+(D||j))/2,G=l([{x:d,y:n.plotY,z:i?-(u-S(n.plotY))/2:-S(n.plotY)/2}],e,!0)[0],n.tooltipPos=[G.x,G.y],n.dlBoxRaw={x:d,width:S(n.plotY),y:L,bottom:k.height||0,fullWidth:u},r&&!1===n.visible||(C+=U)}}return c.compose=e.compose,c.defaultOptions=u(a.defaultOptions,t),p(c.prototype,{pointClass:i,translate3dShapes:d}),o.registerSeriesType("funnel3d",c),c}),i(t,"masters/modules/funnel3d.src.js",[t["Core/Globals.js"],t["Series/Funnel3D/Funnel3DSeries.js"],t["Core/Renderer/RendererRegistry.js"]],function(e,t,i){return t.compose(i.getRendererType()),e})});